﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Transactions;

namespace DataBaseStudio
{
    class Program
    {
        /// <summary>
        /// 测试VS2005事务处理能力
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            /// 看看新的事务处理带的方便性
            using (TransactionScope t = new TransactionScope())
            {
                SqlConnection conn = new SqlConnection(
                    "Data Source=JSL-KEN-2003\\JSL_KEN_2000;Initial Catalog=Northwind;User ID=sa");
                using (conn)
                {
                    conn.Open();
                    using (SqlCommand cmd = conn.CreateCommand())
                    {
                        cmd.CommandText =
                            "Insert Into Region (RegionID,RegionDescription) Values(5,'为人民服务')";
                        cmd.ExecuteNonQuery();
                        // 一直到这里，你的写法和没有进行事务操作的写法一样方便
                        // 不同的地方在下面这一句，加上就像调用了老式事务的Commit一样，上面所有的操作被提交。
                        //t.Complete();
                        //Console.WriteLine("已录入到系统中");
                        Console.WriteLine("没有录入到系统中");
                    }
                }
            }
            Console.ReadLine();
        }

        //老式的事务处理方式
        //static void Main(string[] args)
        //{
        //    SqlConnection conn = new SqlConnection(
        //              "Data Source=JSL-KEN-2003\\JSL_KEN_2000;Initial Catalog=Northwind;User ID=sa");
        //    using (conn)
        //    {
        //        conn.Open();
        //        using (SqlCommand cmd = conn.CreateCommand())
        //        {
        //            cmd.CommandText =
        //                    "Insert Into Region (RegionID,RegionDescription) Values(5,'东北')";
        //            // 在这里用到了SqlTransaction看看有多笨重
        //            SqlTransaction trans = conn.BeginTransaction();
        //            // 这里还要把cmd和trans挂接起来
        //            cmd.Transaction = trans;
        //            cmd.ExecuteNonQuery();
        //            trans.Commit();
        //            Console.WriteLine("已录入一条记录到数据库中");
        //            // trans.Rollback();
        //            // Console.WriteLine("录入记录的操作已被中止");
        //        }
        //        Console.ReadLine();
        //    }
        //}

    }
}
